<?php

/* * ********************************************************************
 *  Provisioning Module for NodePing. Custom developed.
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Bogusław Kotarski <boguslaw.ko@modulesgarden.com>
 */

class NodePingCurl {

    private $errorText = '';

    public function __construct() {
        
    }

    public function get($url, $values) {
        return $this->request('GET', $url, $values);

    }

    public function post($url, $values) {
        return $this->request('POST', $url, $values);

    }

    public function put($url, $values) {
        return $this->request('PUT', $url, $values);

    }

    public function delete($url, $values) {
        return $this->request('DELETE', $url, $values);

    }

    private function request($type, $url, $values) {
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $type);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($values));
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        //curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        $apiResult = curl_exec($ch);
        logModuleCall('nodeping','REQUEST',json_encode($values), $apiResult);
        if ($apiResult == FALSE) {
            $this->errorText = 'Connection error: ' . curl_error($ch) . PHP_EOL;
            curl_close($ch);
            return FALSE;
        }
        curl_close($ch);

        $decodedApiResult = json_decode($apiResult);
        if ($decodedApiResult == NULL) {
            $this->errorText = 'Incorrect JSON data.' . PHP_EOL;
            return FALSE;
        }

        if (isset($decodedApiResult->error)) {
            if (isset($decodedApiResult->error->message)) {
                $this->errorText = $decodedApiResult->error->message . PHP_EOL;
            } else {
                $this->errorText = $decodedApiResult->error . PHP_EOL;
            }
            return FALSE;
        }
        return $decodedApiResult;

    }

    public function getErrorText() {
        return $this->errorText;

    }

}
