<?php

/* * ********************************************************************
 *  Provisioning Module for NodePing. Custom developed.
 * *
 *
 *  CREATED BY MODULESGARDEN       ->       http://modulesgarden.com
 *  CONTACT                        ->       contact@modulesgarden.com
 *
 *
 * This software is furnished under a license and may be used and copied
 * only  in  accordance  with  the  terms  of such  license and with the
 * inclusion of the above copyright notice.  This software  or any other
 * copies thereof may not be provided or otherwise made available to any
 * other person.  No title to and  ownership of the  software is  hereby
 * transferred.
 *
 *
 * ******************************************************************** */

/**
 * @author Bogusław Kotarski <boguslaw.ko@modulesgarden.com>
 */
class MG_NodePing_Product extends MG_WHMCS_NodePing_Product {

    protected $_tableName = 'mg_prodConfig';
    protected $moduleName = 'NodePing';
    public $defaultConfig = array();

    // =========================================


    public function __construct($id) {
        parent::__construct($id);
        if( WHMCS7 ){
            $url = "<a href='configproducts.php?action=edit&id=" . $id . "&generate_conf_opts=true&tab=3'>Generate Default</a>";
        }else{
           $url = "<a href='configproducts.php?action=edit&id=" . $id . "&tab=2&generate_conf_opts=true'>Generate Default</a>";
        }
        $this->defaultConfig = array(
            //module options
            "gro"                           => "Configurable Options",
            "Configurable Options"          => array(
                "type"        => "html",
                "title"       => "Configurable Options",
                "description" => $url,
            ),
            "nodepingMinimalCheckFrequency" => array(
                "type"        => "select",
                "title"       => "Minimal Check Frequency",
                "options"     => array(
                    '1'    => '1 minute',
                    '3'    => '3 minutes',
                    '5'    => '5 minutes',
                    '15'   => '15 minutes',
                    '30'   => '30 minutes',
                    '60'   => '1 hour',
                    '360'  => '6 hours',
                    '720'  => '12 hours',
                    '1440' => '1 day',
                ),
                "description" => "",
                "default"     => "1"
            ),
            'gr0'                           => 'SubAccount',
            "nodepingSubAccountLocation"    => array(
                "type"        => "select",
                "title"       => "Default Location",
                "options"     => array(
                    'nam' => 'North America',
                    'eur' => 'Europe',
                    'eao' => 'East Asia/Oceania',
                    'lam' => 'Latin America',
                    'wlw' => 'Worldwide',
                ),
                "description" => "<br>Default location for new subaccounts.",
                "default"     => "wlw"
            ),
            "nodepingSubAccountTimeZone"    => array(
                "type"        => "select",
                "title"       => "Time Zone for Notifications",
                "options"     => array(
                    '-12.0' => '(GMT -12:00) Eniwetok, Kwajalein',
                    '-11.0' => '(GMT -11:00) Midway Island, Samoa',
                    '-10.0' => '(GMT -10:00) Hawaii',
                    '-9.0'  => '(GMT -9:00) Alaska',
                    '-8.0'  => '(GMT -8:00) Pacific Time (US &amp; Canada)',
                    '-7.0'  => '(GMT -7:00) Mountain Time (US &amp; Canada)',
                    '-6.0'  => '(GMT -6:00) Central Time (US &amp; Canada), Mexico City',
                    '-5.0'  => '(GMT -5:00) Eastern Time (US &amp; Canada), Bogota, Lima',
                    '-4.5'  => '(GMT -4:30) Caracas',
                    '-4.0'  => '(GMT -4:00) Atlantic Time (Canada), Caracas, La Paz',
                    '-3.5'  => '(GMT -3:30) Newfoundland',
                    '-3.0'  => '(GMT -3:00) Brazil, Buenos Aires, Georgetown',
                    '-2.0'  => '(GMT -2:00) Mid-Atlantic',
                    '-1.0'  => '(GMT -1:00 hour) Azores, Cape Verde Islands',
                    '0.0'   => '(GMT) Western Europe Time, London, Lisbon, Casablanca',
                    '1.0'   => '(GMT +1:00 hour) Brussels, Copenhagen, Madrid, Paris',
                    '2.0'   => '(GMT +2:00) Kaliningrad, South Africa',
                    '3.0'   => '(GMT +3:00) Baghdad, Riyadh, Moscow, St. Petersburg',
                    '3.5'   => '(GMT +3:30) Tehran',
                    '4.0'   => '(GMT +4:00) Abu Dhabi, Muscat, Baku, Tbilisi',
                    '4.5'   => '(GMT +4:30) Kabul',
                    '5.0'   => '(GMT +5:00) Ekaterinburg, Islamabad, Karachi, Tashkent',
                    '5.5'   => '(GMT +5:30) Bombay, Calcutta, Madras, New Delhi',
                    '5.75'  => '(GMT +5:45) Kathmandu',
                    '6.0'   => '(GMT +6:00) Almaty, Dhaka, Colombo',
                    '7.0'   => '(GMT +7:00) Bangkok, Hanoi, Jakarta',
                    '8.0'   => '(GMT +8:00) Beijing, Perth, Singapore, Hong Kong',
                    '9.0'   => '(GMT +9:00) Tokyo, Seoul, Osaka, Sapporo, Yakutsk',
                    '9.5'   => '(GMT +9:30) Adelaide, Darwin',
                    '10.0'  => '(GMT +10:00) Eastern Australia, Guam, Vladivostok',
                    '11.0'  => '(GMT +11:00) Magadan, Solomon Islands, New Caledonia',
                    '12.0'  => '(GMT +12:00) Auckland, Wellington, Fiji, Kamchatka',
                    '13.0'  => '(GMT +13:00) Kiribati, Tonga, Samoa',
                ),
                "description" => "<br>Time Zone for new subaccounts.",
                "default"     => "0.0"
            ),
            //available checks
            'gr1'                           => 'Available Checks',
            'nodepingCheckAUDIO'            => array('title' => 'Audio Stream', 'type' => 'checkbox'),
            'nodepingCheckDNS'              => array('title' => 'DNS', 'type' => 'checkbox'),
            'nodepingCheckFTP'              => array('title' => 'FTP', 'type' => 'checkbox'),
            'nodepingCheckHTTP'             => array('title' => 'HTTP', 'type' => 'checkbox'),
            'nodepingCheckHTTPADV'          => array('title' => 'HTTP Advanced', 'type' => 'checkbox'),
            'nodepingCheckHTTPCONTENT'      => array('title' => 'HTTP Content', 'type' => 'checkbox'),
            'nodepingCheckHTTPPARSE'        => array('title' => 'HTTP Parse', 'type' => 'checkbox'),
            'nodepingCheckIMAP4'            => array('title' => 'IMAP4', 'type' => 'checkbox'),
            'nodepingCheckMYSQL'            => array('title' => 'MYSQL', 'type' => 'checkbox'),
            'nodepingCheckNTP'              => array('title' => 'NTP', 'type' => 'checkbox'),
            'nodepingCheckPING'             => array('title' => 'PING', 'type' => 'checkbox'),
            'nodepingCheckPOP3'             => array('title' => 'POP3', 'type' => 'checkbox'),
            'nodepingCheckPORT'             => array('title' => 'PORT', 'type' => 'checkbox'),
            'nodepingCheckPUSH'             => array('title' => 'PUSH', 'type' => 'checkbox'),
            'nodepingCheckRBL'              => array('title' => 'RBL', 'type' => 'checkbox'),
            'nodepingCheckRDP'              => array('title' => 'RDP', 'type' => 'checkbox'),
            'nodepingCheckSIP'              => array('title' => 'SIP', 'type' => 'checkbox'),
            'nodepingCheckSNMP'             => array('title' => 'SNMP', 'type' => 'checkbox'),
            'nodepingCheckSMTP'             => array('title' => 'SMTP', 'type' => 'checkbox'),
            'nodepingCheckSSH'              => array('title' => 'SSH', 'type' => 'checkbox'),
            'nodepingCheckSSL'              => array('title' => 'SSL', 'type' => 'checkbox'),
            'nodepingCheckWEBSOCKET'        => array('title' => 'WebSocket', 'type' => 'checkbox'),
            'nodepingCheckWHOIS'            => array('title' => 'Whois', 'type' => 'checkbox'),
            //Available notifications
            'gr2'                           => 'Available Notifications',
            'nodepingNotificationemail'     => array('title' => 'Email', 'type' => 'checkbox'),
            'nodepingNotificationhipchat'   => array('title' => 'HipChat', 'type' => 'checkbox'),
            'nodepingNotificationpagerduty' => array('title' => 'PagerDuty', 'type' => 'checkbox'),
            'nodepingNotificationpushover'  => array('title' => 'Pushover', 'type' => 'checkbox'),
            'nodepingNotificationslack'     => array('title' => 'Slack', 'type' => 'checkbox'),
            'nodepingNotificationsms'       => array('title' => 'SMS', 'type' => 'checkbox'),
            'nodepingNotificationvoice'     => array('title' => 'Voice', 'type' => 'checkbox'),
            'nodepingNotificationwebhook'   => array('title' => 'Webhook', 'type' => 'checkbox'),

        );

    }

    /**
     * FUNCTION removeConfigs
     * Remove configurations for this product
     * @param string $type
     */
    public function removeConfigs($type) {
        //$configs = $type == 'openvz' ? array('gr2','openvz_os_template','openvz_os_template','openvz_disk','openvz_memory','openvz_swap','openvz_cpus','openvz_storage','openvz_netif','openvz_pool','openvz_force','openvz_onboot','openvz_quotatime','openvz_description','openvz_restore','openvz_searchdomain','openvz_cpuunits','openvz_quotaugidlimit', 'openvz_net_mode', 'openvz_net_bridge','openvz_ip_addresses', 'openvz_backup_limit_gb', 'openvz_backup_limit_maxfile', 'openvz_bandwidth_limit') : $this->getKvmConigKeys();
        $configs = $this->getConigVirtualizationKeys($type);
        foreach ($configs as $k) {
            unset($this->defaultConfig[$k]);
        }

    }

    /**
     * FUNCTION getProxmoxProducts
     * Get configuration for product $id
     * @param int $id
     * @return array
     */
    public function getProxmoxProducts($id) {

        $q      = mysql_safequery("SELECT p.id, p.name FROM `tblproducts` p
                                WHERE p.servertype=? AND id!=?", array("proxmoxVPS", $id));
        $result = array(0 => "");
        while ($row    = mysql_fetch_assoc($q)) {
            $result[$row['id']] = $row['name'];
        }

        return mysql_num_rows($q) ? $result : false;

    }

    /**
     * FUNCTION getKvmConigKeys
     * Get configurations keys for KVM
     * @return array $configKeys
     */
    public function getKvmConigKeys() {
        $configKeys = array();
        foreach ($this->defaultConfig as $k => $v) {
            if (strpos($k, 'kvm_') !== false) {
                $configKeys[] = $k;
            }
        }
        return $configKeys;

    }

    /**
     * FUNCTION 
     * @param type $type
     * @return type
     */
    public function getConigVirtualizationKeys($type) {
        $configKeys = array();
        foreach ($this->defaultConfig as $k => $v) {
            if (strpos($k, $type . '_') !== false) {
                $configKeys[] = $k;
            }
        }
        return $configKeys;

    }

    /**
     * FUNCTION setupDefaultCustomFields
     * Setup default custon fields for this product
     * @return boolean
     */
    public function setupDefaultCustomFields() {

        $q = mysql_safequery('
			SELECT id, relid, fieldname
			FROM tblcustomfields
			WHERE
				relid = ' . $this->id . '
				AND type = "product"
				AND fieldname IN("vmid")
		');

        $fieldnames = array();
        while ($row        = mysql_fetch_assoc($q)) {
            $fieldnames[] = $row['fieldname'];
        }

        $query_raw = 'INSERT INTO tblcustomfields(type,relid,fieldname,fieldtype,description,fieldoptions,regexpr,adminonly,required,showorder,showinvoice,sortorder)
			VALUES("product", ' . $this->id . ', ?, "text", "", "", "", "on", "", "", "", 0)';

        if (!in_array('vmid', $fieldnames))
            mysql_safequery($query_raw, array('vmid'));

        $q          = mysql_safequery('
			SELECT id, relid, fieldname
			FROM tblcustomfields
			WHERE
				relid = ' . $this->id . '
				AND type = "product"
				AND fieldname IN("node", "storage", "backup storage", "VLAN Tag")
		');
        $fieldnames = array();
        while ($row        = mysql_fetch_assoc($q)) {
            $fieldnames[] = $row['fieldname'];
        }

        if (!in_array('node', $fieldnames))
            mysql_safequery($query_raw, array('node'));

        if (!in_array('storage', $fieldnames))
            mysql_safequery($query_raw, array('storage'));

        if (!in_array('backup storage', $fieldnames))
            mysql_safequery($query_raw, array('backup storage'));

        if ($this->getConfig("virtualization_type") == "KVM" && !in_array('VLAN Tag', $fieldnames))
            mysql_safequery($query_raw, array('VLAN Tag'));


        return true;

    }

    /**
     * FUNCTION hasCustomField
     * Is custom field $name
     * @param sting $name
     * @return boolean
     */
    public function hasCustomField($name) {

        $q = mysql_safequery('SELECT id FROM tblcustomfields WHERE type = "product" AND relid = ' . (int) $this->id . ' AND fieldname = "' . mysql_real_escape_string($name) . '"');
        return (bool) mysql_num_rows($q);

    }

    /**
     * FUNCTION hasConfigurableOptions
     * Is configurable options for this products
     * @return boolean
     */
    public function hasConfigurableOptions() {
        $q = mysql_safequery('SELECT * FROM tblproductconfiglinks plink 
                                  JOIN `tblproductconfiggroups` pcgr ON plink.gid = pcgr.id
                                  WHERE plink.pid = ?
                                  ', array($this->id));
        return (bool) mysql_num_rows($q);

    }

    /**
     * FUNCTION getParams
     * Get server and this product params
     * @return array
     */
    public function getParams() {
        $result = mysql_query_safe("
                                              SELECT
                                                  s.ipaddress AS serverip, s.hostname AS serverhostname, s.username AS serverusername, s.password AS serverpassword, s.secure AS serversecure,
                                                  s.accesshash AS serveraccesshash,
                                                     configoption1,configoption2,configoption3,configoption4,configoption5,configoption6,configoption7,configoption8,configoption9
                                              FROM tblservers AS s
                                              JOIN tblservergroupsrel AS sgr ON sgr.serverid = s.id
                                              JOIN tblservergroups AS sg ON sgr.groupid = sg.id
                                              JOIN tblproducts AS p ON p.servergroup = sg.id
                                              WHERE p.id = ?
                                              ORDER BY s.active DESC
                                              LIMIT 1", array($this->id)
        );
        $row    = mysql_fetch_assoc($result);
        // old whmcs
        if (!empty($row)) {
            if (!function_exists('decrypt') && file_exists(ROOTDIR . DS . 'includes' . DS . 'functions.php'))
                include_once ROOTDIR . DS . 'includes' . DS . 'functions.php';
            $row['serverpassword'] = decrypt($row['serverpassword']);
        }
        return $row;

    }

    public function getConfigurableOptionId($moduleName) {
        $conigs = mysql_get_array('SELECT * FROM tblproductconfiglinks WHERE pid = ?', array($this->id));
        foreach ($conigs as $c) {
            $group_id = $c['gid'];

            $option = mysql_get_row("SELECT * FROM `tblproductconfigoptions` WHERE `optionname` LIKE ? AND `gid`=? LIMIT 1", array($moduleName . '|%', $group_id));
            if (empty($option))
                continue;
            return $option['id'];
        }

    }

    public function getConfigurableSubOptionId($optionId, $subOptionModuleName) {
        $subOptions = mysql_get_row('SELECT * FROM tblproductconfigoptionssub WHERE configid = ? AND optionname LIKE ? LIMIT 1', array($optionId, $subOptionModuleName . "|%"));
        return $subOptions['id'];

    }

    public function getNodePingAttributes() {
        $items = array_keys($this->defaultConfig);
        $keys  = preg_grep('/nodeping.+/', $items);
        return $keys;

    }

}
