<?php

if (!defined("WHMCS")) {
    die('This file cannot be accessed directly');
}

use Illuminate\Database\Capsule\Manager as Capsule;

/*
*  Update service configurable options when addon is activated
*/
function nodePing_addon_enable( $vars ){
    try{
        $serviceId = $vars['serviceid'];
        $service = Capsule::table('tblhosting')->where('id',$serviceId)->get();
        $product = Capsule::table('tblproducts')->where('id',$service[0]->packageid)->get();
        if( $product[0]->servertype == 'nodePing' ){
            $addon = Capsule::table('tbladdons')->where('id',$vars['addonid'] )->get();
            $monitors = explode(' ',$addon['0']->name);
            $checksCo = Capsule::table('tblproductconfigoptions')->where('optionname','nodePingChecks|Checks limit')->get();
            $contactsCo = Capsule::table('tblproductconfigoptions')->where('optionname','nodePingContacts|Contacts limit')->get(); 
            $checksValue = Capsule::table('tblhostingconfigoptions')->where('relid',$serviceId)->where('configid',$checksCo['0']->id)->get();
            $newChecksValue = $checksValue[0]->qty + $monitors[0];
            Capsule::table('tblhostingconfigoptions')->where('relid',$serviceId)->where('configid',$checksCo['0']->id)->update(['qty' => $newChecksValue]);
            Capsule::table('tblhostingconfigoptions')->where('relid',$serviceId)->where('configid',$contactsCo['0']->id)->update(['qty' => $newChecksValue]);
        }
    }catch(\Exception $e){
    }
};

/*
*  Update service configurable options when addon is suspended/terminated/cancelled.
*/
function nodePing_addon_disable( $vars ){
    try{
        $serviceId = $vars['serviceid'];
        $service = Capsule::table('tblhosting')->where('id',$serviceId)->get();
        $product = Capsule::table('tblproducts')->where('id',$service[0]->packageid)->get();
        if( $product[0]->servertype == 'nodePing' ){
            $addon = Capsule::table('tbladdons')->where('id',$vars['addonid'] )->get();
            $monitors = explode(' ',$addon['0']->name);
            $checksCo = Capsule::table('tblproductconfigoptions')->where('optionname','nodePingChecks|Checks limit')->get();
            $contactsCo = Capsule::table('tblproductconfigoptions')->where('optionname','nodePingContacts|Contacts limit')->get();
            $checksValue = Capsule::table('tblhostingconfigoptions')->where('relid',$serviceId)->where('configid',$checksCo['0']->id)->get();
            $newChecksValue = $checksValue[0]->qty - $monitors[0];
            Capsule::table('tblhostingconfigoptions')->where('relid',$serviceId)->where('configid',$checksCo['0']->id)->update(['qty' => $newChecksValue]);
            Capsule::table('tblhostingconfigoptions')->where('relid',$serviceId)->where('configid',$contactsCo['0']->id)->update(['qty' => $newChecksValue]);
        }
    }catch(\Exception $e){
    }
}
add_hook('AddonActivated',99,'nodePing_addon_enable');
add_hook('AddonUnsuspended',99,'nodePing_addon_enable');
add_hook('AddonSuspended',99,'nodePing_addon_disable');
add_hook('AddonCancelled',99,'nodePing_addon_disable');
add_hook('AddonTerminated',99,'nodePing_addon_disable');



if (!defined('DS')) {
    define('DS', DIRECTORY_SEPARATOR);
}

if (function_exists('mysql_safequery') == false) {

    /**
     * Function for SQL queries
     * @param string $query
     * @param array $params
     * @return mysql reqource
     */
    function mysql_safequery($query, $params = false) {
        if ($params) {
            foreach ($params as &$v) {
                $v = mysql_real_escape_string($v);
            }
            $sql_query = vsprintf(str_replace("?", "'%s'", $query), $params);
            $sql_query = mysql_query($sql_query);
        } else {
            $sql_query = mysql_query($query);
        }

        return ($sql_query);

    }

}


// Hook on product action save
require_once(dirname(__FILE__) . DS . "classes" . DS . "class.Product.php");
require_once(dirname(__FILE__) . DS . "classes" . DS . "class.MG_NodePing_Product.php");
require_once(dirname(__FILE__) . DS . "classes" . DS . "class.WHMCS_Product.php");

if (preg_match('/configproducts\.php\?action=save/', $_SERVER['REQUEST_URI'])) {
    $product = new MG_NodePing_Product((int) $_GET['id']);
    $attr    = $product->getNodePingAttributes();
    if (isset($_POST['customconfigoption']) && is_array($_POST['customconfigoption'])) {
        foreach ($_POST['customconfigoption'] as $key => $opt) {
            $product->saveConfig($key, $opt);
            if (($key2 = array_search($key, $attr)) !== false) {
                unset($attr[$key2]);
            }
        }
    }
    foreach ($attr as $item) {
        $product->saveConfig($item, '');
    }
}
if( isset( $_GET['generate_conf_opts'] ) && $_GET['generate_conf_opts'] ){
    $id = $_GET['id'];
    $product = new NodePing_Product($id);
    if (!$product->hasConfigurableOptions()) {
        $product->setupDefaultConfigurableOptions();
        ob_clean();
        if( WHMCS7 ){
            $location = 'Location: configproducts.php?action=edit&id=' . $id . '&tab=5&success=true';
        }else{
            $location = 'Location: configproducts.php?action=edit&id=' . $id . '&tab=' . (WHMCS6 ? '5' : '4') . '&success=true';
        }
        header($location);
    } else {
        ob_clean();
        header('Location: configproducts.php?action=edit&id=' . $id . '&tab=' . (WHMCS6 ? '3' : '2') . '&error=exist');
        exit();
    }
}


